SystemOrganization addCategory: #MuODeployement!


Object subclass: #MuODeployer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuODeployement'!

MuODeployer class
	instanceVariableNames: ''!

Object subclass: #SurmulotWidgetWindowEventHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuODeployement'!

SurmulotWidgetWindowEventHandler class
	instanceVariableNames: ''!


!MuODeployer commentStamp: 'spfa 5/6/2006 23:31' prior: 0!
Responsible for the deployement of µO

- generation of a *.sar archive from a development image
- installation from *.sar into a fresh image
- saving of a public image from a development image
- transformation of a public image into a TCP/IP-driven widget
!
]style[(256)!

!MuODeployer class methodsFor: 'welcoming' stamp: 'spfa 11/18/2009 18:14'!
aboutToEnterMuOWorld

	(World hasProperty: #wasEntered)
		ifTrue: [^ self].

	self firstTimeActions ifTrue: [World getProperty: #wasEntered]! !

!MuODeployer class methodsFor: 'muO SAR release' stamp: 'spfa 11/18/2009 18:14'!
additionalFiles

	"MuODeployer additionalFiles"

	| flist |

	flist _ Set new.

	Preferences includeBooksInMuORelease 
		ifTrue: [flist addAll: (MuO booksForRelease 
									select: [:d | d fileExists]
									thenCollect: [:d | d file])].

	^ flist! !

!MuODeployer class methodsFor: 'ancilliary packages' stamp: 'spfa 11/18/2009 18:14'!
fileOutFunctionalTalk

	ChangeSetPackageExporter fileOutPackageNamed: 'FunctionalTalk'.! !

!MuODeployer class methodsFor: 'ancilliary packages' stamp: 'spfa 11/18/2009 18:14'!
fileOutMuOMaths

	SARPackageDumper fileOutPackage: MuOMathsInfo new 
		as: ('muOmaths.%s.sar' sformat: MuOMathsInfo version) ! !

!MuODeployer class methodsFor: 'welcoming' stamp: 'spfa 11/18/2009 18:14'!
firstTimeActions

	| menu book |

	"clean up"
	(FileDirectory default fileExists: 'muO welcome.pr')
		ifTrue: ['muO welcome.pr' asFileReference kill].

	menu _ MuO mainMenu stayUp: true. 
	menu openInWorld; bottomRight: World center.

	book _  (FileDirectory default 
				fullNameFor: 'muo books\DocBook entry points.morph').
	(FileDirectory default fileExists: book)
		ifTrue: [Morph fromLocalFileName: book].

	self inform: 'Welcome to muO !!
-
This is the first time you enter this project.
For a start please read the ''Entry points to muO'' book, then play with 
the ''muO objects'' menu (see notably the ''live documentation'' submenu).
-'.

	^ true! !

!MuODeployer class methodsFor: 'muO SAR release' stamp: 'spfa 2/7/2014 16:32'!
handleInstallationFiles

	MuOInfo new installationFiles do: [:ea |
		ea asFileReference exists ifFalse: [self error: 'Missing file: ', ea].
		ea asFileReference copyAs: 
			('ifiles', FileDirectory pathNameDelimiter, ea) asFileReference]! !

!MuODeployer class methodsFor: 'snippets' stamp: 'spfa 5/4/2010 15:02'!
incrementMuOVersion

	"MuODeployer incrementMuOVersion"

	(self confirm: ('µO version jump to %s ?' sformat: MuOInfo version + 1))
		ifFalse: [^ self].

	MuOInfo class compile: ((
'
version

	^ %s
'
					) sformat: (MuOInfo version + 1))! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 4/22/2010 17:22'!
installAll: anArray

	| wmorphs |

	wmorphs _ World submorphs.

	anArray do: [:packageName |
			| dir fname |
			dir _ self packagesCacheDirectory.
			dir assureExistence.
			(dir fileExists: packageName)
				ifFalse:[self error: 'missing package ', packageName].
			fname _ dir fullNameFor: packageName.
			[
				(fname findTokens: '.') last asUppercase caseOf:
				{	
					['MCZ'] -> [MczInstaller installFileNamed: fname].
					['SAR'] -> [SARInstaller installSAR: fname]
				}
			] on: Error
			do: 
			[
				(self confirm: 'Installation of ', fname, ' failed. Proceed anyway ?')
					ifFalse: [self error:  'Installation of ', fname, ' failed']
			]
		].

	 World submorphs do: [:m | 
		(wmorphs identityIncludes: m) ifFalse: [m delete]].
! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 4/22/2010 17:17'!
installRequiredPackages

	self installAll: self requiredPackages! !

!MuODeployer class methodsFor: 'muO image release' stamp: 'spfa 9/11/2011 20:55'!
makeImageRelease

	self releaseImageAs: 'muO.image'
			enable: {
						#enableMuOManagers .
						#stickToManager .
						#surmulotComponent . 

						#editFilesWithEmacs .
						#editTextsWithEmacs .
						#emacsSocketIsADaemon .
	"					#listenToEmacsAtStartup ."
						#silentlyIgnoreErrorsFromEmacs .

						#enableCsoundInteraction .
	"					#enableLowkeyInteraction ."
						#enableSoundEditorInteraction .
						#enableSoundPlayerInteraction .
						#enableMF2TInteraction .
						#enableT2MFInteraction .
						#enableTimidityInteraction .

	"					#duplicateControlAndAltKeys ."
					}
			disable: {
						#enableLowkeyInteraction .
						#enableMIDIEditorInteraction .

						#logEmacsSession.

						#warnIfNoSourcesFile .
						#warnIfNoChangesFile .

						#preserveTrash .
						#slideDismissalsToTrash . 						#syntaxHighlightingAsYouTypeAnsiAssignment .
												
						#menuKeyboardControl
					}! !

!MuODeployer class methodsFor: 'widget image setup' stamp: 'spfa 11/26/2013 17:48'!
makeWidget: aMorph extent: aPoint port: aNumber

	| bbox |

	"Transform the current image into an emacs widget listening to a local port"

	Preferences disable: #surmulotComponent.
	Preferences disable: #enableMuOManagers.
	Preferences disable: #stickToManager.
	SurmulotManager disconnect.

	Preferences enable: #listenToEmacsAtStartup.
	Preferences enable: #accessShellViaEmacs.

	Preferences disable: #higherPerformance.

	SmalltalkImage current closeSourceFiles.
	SmalltalkImage current primImageName: ('widget %s' sformat: aNumber) .

	World submorphs do: [:m | m privateDelete].

	SmalltalkImage current platformName = 'Win32' ifTrue: [
		DisplayScreen depth: 32 width: aPoint x height: aPoint y fullscreen: false].
	Flaps disableGlobalFlaps: false.

	World layoutPolicy: ProportionalLayout new.
	World windowEventHandler: SurmulotWidgetWindowEventHandler.

	ChangeSet newChanges:
		(ChangeSorter basicNewChangeSet: 'widget changeset'). 

	aMorph behaveAsSurmulotWidget.
	
	EmacsInteraction startOnPort: aNumber.		
	
	(aMorph hasProperty: #smallWidget) ifFalse: [^ self].

	(bbox _ aMorph boundingBoxOfSubmorphs) = aMorph bounds
		ifTrue: [^ self].

	bbox _ bbox extendBy: 10. "heuristic"

	DisplayScreen depth: 32 
		width: bbox width height: bbox height fullscreen: false.
		
	
! !

!MuODeployer class methodsFor: 'widget image setup' stamp: 'spfa 11/18/2009 18:14'!
makeWidgetImage

	self makeWidgetImage: 'widget.image' extent: 650@450 
! !

!MuODeployer class methodsFor: 'widget image setup' stamp: 'spfa 11/18/2009 18:14'!
makeWidgetImage: aString extent: aPoint 

	Preferences disable: #surmulotComponent.
	Preferences disable: #enableMuOManagers.
	Preferences disable: #stickToManager.

	SmalltalkImage current closeSourceFiles.
	SmalltalkImage current primImageName: aString .

	DisplayScreen depth: 32 width: aPoint x height: aPoint y fullscreen: false.

	Flaps globalFlapTabsIfAny
		do: [:ft | Flaps removeFlapTab: ft keepInList: false].

	World removeAllMorphs.
	MuO logo openInWorld.

	SmalltalkImage current snapshot: true andQuit: true! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 11/18/2009 18:14'!
packagesCacheDirectory

	^	FileDirectory default directoryNamed:  'muo-cache'! !

!MuODeployer class methodsFor: 'muO image release' stamp: 'spfa 8/2/2010 15:01'!
releaseImageAs: releaseName enable: truePrefs disable: falsePrefs

"... voir ReleaseBuilder>>makeSqueaklandRelease pour inspiration"

	SmalltalkImage current saveAs: releaseName. 

	Project current setParent: Project current.
	Project removeAll: (Project allSubInstances copyWithout: Project current).
	Project current changeSet name: 'muO'.

	MuO cleanUp.
	MIDIOutputRecorder reset.

	"Launcher initialization"
	ProjectLauncher deactivate.
	MuOLauncher activate.

	"Morphic references hide there:"
	WorldState deferredUIMessages flush.
	SurmulotManager killEmacsFlap; killKeykitFlap.
	HandMorph allInstances do: [:h | h pasteBuffer: nil].
	SketchEditorMorph allInstances do: [:m | m clearEnclosingPasteUpMorph].

	PluggableTextMorph allSubInstancesDo: 
		[:ptm | ptm hasUnacceptedEdits: false].

	ZoomableFieldMorph allSubInstancesDo: [:m | m releaseCachedState].
	MGraphElementMorph allSubInstancesDo: [:m | m releaseCachedState].
	MGraphBook allSubInstancesDo: [:m | m releaseCachedState].
	Notebook allSubInstancesDo: [:m | m releaseCachedState].
	SketchMorph allSubInstancesDo: [:m | m releaseCachedState].
	ThumbnailMorph allSubInstancesDo: [:m | m releaseCachedState].

	Player freeUnreferencedSubclasses.
	Smalltalk cleanOutUndeclared.
	Behavior flushObsoleteSubclasses.
	Smalltalk garbageCollect; garbageCollect.
	DataStream initialize.
	CommandHistory resetAllHistory.

	Smalltalk garbageCollect.
	
	truePrefs	do: [:pref | Preferences enable:  pref].
	falsePrefs	do: [:pref | Preferences disable:  pref].

	SurmulotManager defineExternalEnvironment.
	Utilities initializeCommonRequestStrings.
	#(
		'-'
		'Color displayNamedColors' 
	) do: [:s | Utilities appendToCommonRequests: s].	

	Smalltalk garbageCollect.
	Smalltalk forgetDoIts.
	Smalltalk cleanOutUndeclared.
	Smalltalk garbageCollect.

	Smalltalk flushClassNameCache.
	3 timesRepeat: 
			[Smalltalk garbageCollect.
			Symbol compactSymbolTable].

	MuO cleanUp.
"
	(self confirm: 'condense changes files ?')
		ifTrue: [Smalltalk condenseChanges].
"

	Utilities authorInitialsPerSe ifEmpty:
		[Utilities setAuthorInitials: 'muOuser'].

	SmalltalkImage current snapshot: true andQuit: true! !

!MuODeployer class methodsFor: 'muO SAR release' stamp: 'spfa 2/7/2014 16:26'!
releaseMuOPackage

	"MuODeployer releaseMuOPackage"

	(self confirm: ('release muO.%s.sar ?' sformat: MuOInfo version))
		ifFalse: [^ self].

	self handleInstallationFiles.

	MuO cleanUp.

	Preferences saveBooksUponMuORelease 
		ifTrue: [self saveAllBooks].

	MuO compileReleaseBooks.
	
	MuOInfo encodeMonkeyPackagesDevelVersions.

	MuOInfo new installationFiles do: [:sf | 
		sf asFileReference exists ifFalse: [self error: 'missing file: ', sf]].

	MusicalElementRepository compileRepositories.
	CsoundSynthesizer compileLibrary.

	ChangeSetPackageExporter fileOutPackageNamed: 'MuODeployement'.
"	ChangeSetPackageExporter fileOutPackageNamed: 'MuO39-hacks'." 

	SARPackageDumper fileOutPackage: MuOInfo new 
		as: ('muO.%s.sar' sformat: MuOInfo version) .
		
	MusicalElementRepository allSubclasses do: [:c | c initialize].
	CsoundSynthesizer initialize! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 2/11/2012 01:20'!
requiredPackages

	"3.8 and 3.8.1:"

	(SystemVersion current majorMinorVersion = 'Squeak3.8') ifTrue: 
		[^ #(
				'ConnectorsFor38-185.sar'
				'OSProcessV4-0-1.1.sar'
		"		'Regex5.sar'     "
				'PreferenceBrowser-hpt.22.mcz'
				'OSC-SimonHolland.14.mcz'
				'Network-HTML-md.4.mcz'
				'Scamper-md.3.mcz'
				'ExternalWebBrowser-dd.7.1.mcz'
				'TestBrowser-tbn.119.mcz'
				'InstanceEncoder-jrp.9.mcz'
				'shout4.sar'
				'SophiePort-SeanDeNigris.1.mcz')].

	(SystemVersion current majorMinorVersion >= 'Squeak4.1') ifTrue: 
		[^ #(
				'ConnectorsFor38-185.sar'
				'OSProcess-dtl.59.mcz'
		"		'Regex5.sar'         "
				'OSC-SimonHolland.14.mcz'
		"		'FFI-Pools-ar.1.mcz'
				'FFI-Kernel-ar.16.mcz'
				'FFI-Examples-ar.1.mcz'
				'FFI-Tests-ar.3.mcz'      "
				'HTML-md.1.mcz'
				'Scamper-kfr.12.mcz'
				'TestBrowser-tbn.119.mcz'
				'InstanceEncoder-jrp.9.mcz'
				'VB-Regex-nice.18.mcz'
				'SophiePort-SeanDeNigris.1.mcz')].


	"3.9 and 3.10:"

		^ #(
				'ConnectorsFor38-185.sar'
				'OSProcessV4-0-1.1.sar'
		"		'Regex5.sar'         "
				'OSC-SimonHolland.14.mcz'
				'HTML-md.1.mcz'
				'Scamper-kfr.12.mcz'
				'TestBrowser-tbn.119.mcz'
				'InstanceEncoder-jrp.9.mcz'
				'shout4.sar'
				'SophiePort-SeanDeNigris.1.mcz') 
! !

!MuODeployer class methodsFor: 'snippets' stamp: 'spfa 11/18/2009 18:14'!
resetStrikeFontsEmphasis

	"fix a weird problem in my development image - spfa"

	(StrikeFont allInstances select: [:f | 
		f name last isDigit and: [f emphasis isZero not]] )
	do: [:f | f emphasis: 0]! !

!MuODeployer class methodsFor: 'snippets' stamp: 'spfa 1/14/2012 22:58'!
saveAllBooks

	"MuODeployer saveAllBooks"

	self resetStrikeFontsEmphasis.

	Utilities informUserDuring:[:blah |
		(MGraphBook allInstances 
			select: [:book | book isDocumentation 
								& book hasUsualFile])
			do: [:book |
					| n p psbv |
					n _ book pageNumber.
					p _ book position.				
					(book pages allSatisfy: [:page |
						(page externalName beginsWith: 'page') not
							and: [page externalName first isDigit not]
							and: [page knownName notNil]])
						ifTrue: [book pagesControls]
						ifFalse: [book fewerPageControls].
					book center:  400@300.
					book goToPage: 1.
					psbv _ book pages collect: [:ea |
						ea -> ((ea isKindOf: MGraphPluggableTextMorph)
							ifTrue: [ea scrollBar value] ifFalse: [nil])].
					psbv do: [:assoc |
						assoc value ifNotNil: [assoc key scrollBar setValue: 0].
						assoc key getProperty: #refuseDroppedMorphs].						
					blah value: book externalName.
					book saveOnUsualFile.
					psbv do: [:assoc |
						assoc value ifNotNil: [assoc key scrollBar setValue: assoc value].
						assoc key removeProperty: #refuseDroppedMorphs].
					book goToPage: n.
					book position: p]].

	Utilities informUserDuring:[:blah |
		(SystemWindow allInstances 
			select: [:sw | sw isDocumentation 
								& sw hasUsualFile])
			do: [:sw |
					| p cp nb sbv |
					p _ sw position.
					cp _ sw isCollapsed.
					sw expand.
					sw center:  400@300.
					nb _ sw submorphs detect: [:m | m isKindOf: Notebook] ifNone: [nil].
					nb ifNotNil: [sbv _ nb scrollBar value. nb scrollBar setValue: 0].
					blah value: sw externalName.
					sw saveOnUsualFile.
					sw position: p.
					nb ifNotNil: [nb scrollBar setValue: sbv].					
					cp ifTrue: [sw collapse]]]! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 11/18/2009 18:14'!
smInstallAll: aListOfIds

	[SMSqueakMap default reload] on: Error
		do: [SMSqueakMap default loadFull].

	^	aListOfIds do: [:id | SMSqueakMap default installPackageReleaseWithId: id]
! !

!SurmulotWidgetWindowEventHandler class methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2010 09:56'!
windowEvent: anEvent

	anEvent type == #windowClose ifFalse: [^ World layoutChanged].
	
	[
		EmacsInteraction evalElisp: 
			('(run-with-timer 0.1 nil (lambda () (surmulot-widget-close %s)))' 
				sformat: EmacsInteraction port)
	] on: Error 
	do: [MuO closeWidget]! !
