SystemOrganization addCategory: #REPLMorph!


PluggableTextMorphWithModel subclass: #REPLMorph
	instanceVariableNames: 'evaluator commandsHistory lastAnswer lastError debugContinuation lastValue queue outputQueueProcess semaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

ParagraphEditor subclass: #LegacyTextMorphEditor
	instanceVariableNames: 'morph oldInterval pivotBlock editHistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

LegacyTextMorphEditor class
	instanceVariableNames: ''!

LegacyTextMorphEditor subclass: #REPLTextMorphEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

REPLTextMorphEditor class
	instanceVariableNames: ''!

REPLMorph subclass: #Notebook
	instanceVariableNames: 'geometriesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

TextMorphForEditView subclass: #REPLTextMorphForEditView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

REPLTextMorphForEditView class
	instanceVariableNames: ''!

REPLMorph class
	instanceVariableNames: ''!

Notebook class
	instanceVariableNames: ''!

Object subclass: #NotebookCell
	instanceVariableNames: 'start end endInput notebook promptMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

NotebookCell class
	instanceVariableNames: ''!

PluggableTextMorph subclass: #REPLPluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

REPLPluggableTextMorph class
	instanceVariableNames: ''!


!LegacyTextMorphEditor commentStamp: 'spfa 4/26/2012 18:55' prior: 0!
This is the ParagraphEditor for TextMorphs in Squeak versions up to 4.3 (included)
!
]style[(83)!

!Notebook commentStamp: 'spfa 4/4/2010 00:25' prior: 0!
A Notebook is a mutated REPLMorph which allows nice formatting of the expressions output (notably the embedding of output morphs), along with operations on cells (each couple expression/output forms a NotebookCell) such as trimming, reordering and commenting !
]style[(259)!

!REPLMorph commentStamp: '<historical>' prior: 0!
a PluggableTextMorph providing a read-eval-print loop for interaction with an interpreter or compiler, called evaluator

evaluator must provide a #prompt, an #outputStream and an #evalString: method !
]style[(199)!

!REPLTextMorphEditor commentStamp: 'spfa 11/30/2011 13:32' prior: 0!
A REPLTextMorphEditor preserves the structure of a REPLMorph by making areas of its text not modifiable
!
]style[(104)!

!LegacyTextMorphEditor methodsFor: 'menu messages' stamp: 'spfa 4/19/2012 12:03'!
accept
	"Save the current text of the text being edited as the current acceptable version for purposes of canceling.  Allow my morph to take appropriate action"
	morph acceptContents! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 11/30/2011 11:13'!
accept
	
	self isInEditableForm ifTrue: [^ super accept]
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
acceptDroppingMorph: aMorph event: evt inMorph: dstListMorph 
	
	| commands |

	(aMorph hasProperty: #replCommands) ifFalse: [^ self].

	commands := (aMorph valueOfProperty: #replCommands) 					difference: self commandsHistory.

	((commands size > 1
		and: [self confirm: 'Add these ', commands size asString, ' commands to history ?'])
	or: [(commands size = 1
		and: [self confirm: 'Add this command to history ?'])])
		ifFalse: [^ self addMorph: aMorph].

	commands do: [:command | self registerCommand: command].
	^ true

! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/29/2011 15:42'!
acceptTextInModel

	| cell |

	self text indexOf: self promptCharacter startingAt: selectionInterval max 
		ifAbsent: [^ super acceptTextInModel].

	"update targeted cell, if any"
	cell := NotebookCell at: (self text embeddedMorphsIndexes 
			reverseDetect: [:a |
				a key < selectionInterval last  
					and: [a value hasProperty: #notebookPrompt]]
			ifNone: [^ false]) value.
	self registerCommand: cell liveInput.
	cell refresh.

	self getProperty: #refreshDisplay. "else the prompt does not show up"

	^ true! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/29/2011 17:12'!
acceptTextInModel

	| textToAccept command |

	(self hasProperty: #inCommand)
	ifFalse:
	[
		command := self currentCommand.
		command ifEmpty: [command := self pointedCommand].
		(command isNil or: [command isEmpty]) ifTrue: [^ self].
		self insertCommand: command.
	].

	textToAccept := self text.
	^setTextSelector isNil or:
		[setTextSelector numArgs = 2
			ifTrue: [model perform: setTextSelector with: textToAccept with: self]
			ifFalse: [model perform: setTextSelector with: textToAccept]]
! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 4/2/2010 09:09'!
adaptCommand: aString

	^ aString! !

!Text methodsFor: '*REPLMorph' stamp: 'spfa 11/18/2009 18:17'!
addAttributes: anArray

	anArray do: [:att | self addAttribute: att]! !

!Text methodsFor: '*REPLMorph' stamp: 'spfa 11/18/2009 18:17'!
addAttributes: anArray from: anIndex to: bIndex

	anArray do: [:att | self addAttribute: att  from: anIndex to: bIndex]! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 22:19'!
addCell: input comment: comment status: aSymbol

	self updateText: myContents, 
		(self cellTextWithInput: input status: aSymbol), String cr asText.

	self refreshDisplay: ''.

	comment ifNil: [^ self].
	self lastCell prependComment: comment asText! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 4/3/2010 23:33'!
addControlButtonsTo: controls for: aMorph

	
! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
addEditCommand: anEditCommand

	self editHistory rememberCommand: anEditCommand.
"
	Debug dShow: anEditCommand newText.
	Debug dShow: anEditCommand replacedText.
"


! !

!Notebook methodsFor: 'menu' stamp: 'spfa 4/3/2010 18:15'!
addItemsToREPLMenu: aMenu

	super addItemsToREPLMenu: aMenu.

	aMenu 
		add: 'explore bindings' target: evaluator bindings action: #explore! !

!Notebook methodsFor: 'menu' stamp: 'spfa 11/18/2009 18:14'!
addREPL

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 0.5@1).
		sw addMorph: (REPLMorph on: self evaluator) frame: (0.5@0 corner: 1@1)]

	! !

!Notebook methodsFor: 'menu' stamp: 'spfa 11/18/2009 18:14'!
addWREPL

	| wks |

	wks := PluggableTextMorph 
			on: self evaluator text: nil 
			accept: #evalText:from: readSelection: nil menu: nil.

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 0.5@1).
		sw addMorph: wks frame: (0.5@0 corner: 1@0.5).
		sw addMorph: (REPLMorph on: self evaluator) 
			frame: (0.5@0.5 corner: 1@1)]

	! !

!LegacyTextMorphEditor methodsFor: 'private' stamp: 'spfa 4/19/2012 12:03'!
againOrSame: bool 
	| bk keys |
	(bk := morph ownerThatIsA: BookMorph) ifNotNil: 
			[(keys := bk valueOfProperty: #tempSearchKey ifAbsent: [nil]) ifNil: 
					["Cmd-f"

					keys := bk valueOfProperty: #searchKey ifAbsent: [nil]	"Cmd-g"]
				ifNotNil: [bk removeProperty: #tempSearchKey].
			keys ifNotNil: 
					[keys notEmpty
						ifTrue: 
							[bk findText: keys.
							^(morph respondsTo: #editView) 
								ifTrue: [morph editView selectionInterval: self selectionInterval]]]].
	super againOrSame: bool.
	(morph respondsTo: #editView) 
		ifTrue: [morph editView selectionInterval: self selectionInterval]! !

!LegacyTextMorphEditor methodsFor: 'menu messages' stamp: 'spfa 4/19/2012 12:03'!
align
	"Align text according to the next greater alignment value,
	cycling among leftFlush, rightFlush, center, and justified."
	self changeAlignment.
	self recomputeInterval! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
anew

	^ self class at: promptMorph! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
answerAttributes

	^ {TextColor color: Color gray darker}! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
appendEntry

	| stream text |

	stream := evaluator outputStream.
	stream isEmpty ifTrue: [^ self].

	text := stream contents.
	stream resetContents.
	
	self queue nextPut: ((text asString copyReplaceAll: String lf with: String cr)
		asText 
			addAttribute: self class displayAttribute;
			addAttribute: self class displayFontAttribute).
! !

!NotebookCell class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:14'!
at: aMorph
	
	^ self new initializeAt: aMorph! !

!Notebook methodsFor: 'experimental' stamp: 'spfa 11/29/2011 17:12'!
atEndOfPointedCommand

	| text index |

	text := self text asString.
	index := selectionInterval min + 2.
	index > text size ifTrue: [^ true].
	^ (text at: index) = self separatorCharacter
	! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/29/2011 17:09'!
atEndOfPointedCommand

	| text index |

	text := self text asString.
	index := selectionInterval min.
	^ index = text size or: [(text at: index + 1) = self separatorCharacter]
	! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 12/21/2012 11:42'!
backspace: characterStream 

	self isInEditableForm ifFalse: [^ true].

	(self isOnPromptLine and: [model startOfCurrentCommand > self selectionInterval min]) 
		ifTrue: [^ true].	

	(model text asString at: self selectionInterval min) = model separatorCharacter
		ifTrue: [^ true].

	(self isOnPromptLine not and: [model pointedCommandBeforeCursor isEmpty])
		ifTrue: [^ true].	

	^ super backspace: characterStream ! !

!LegacyTextMorphEditor methodsFor: 'binding' stamp: 'spfa 4/19/2012 12:03'!
bindingOf: aString
	^model bindingOf: aString! !

!Notebook methodsFor: 'menu' stamp: 'spfa 11/30/2011 14:24'!
buildMenu: aMenu

	super buildMenu: aMenu.

	aMenu addLine;
		add: 'remove all output' target: self action: #removeAllOutput;
		add: 'evaluate all cells' target: self action: #evaluate;
		add: 'copy from cells' target: self action: #rewritedFromCells;
		add: 'edit a copy from cells' target: self action: #editCopyFromCells.		.

	(self hasProperty: #storage) ifTrue: [
		| m |
		m := self valueOfProperty: #storage.
		aMenu addLine.
		aMenu add: 'store in ', m receiver asString, '>>', m selector
			target: (self lambda storeAsSelector: m selector in: m receiver)
			action: #value
	].

	(owner isSystemWindow
		and: [(self hasProperty: #disallowGeometryChanges) not]) 
	ifTrue: [
		aMenu addLine.
		(owner submorphs count: [:m | m isMorphicModel]) = 1 ifTrue: [
			aMenu add: 'add REPL' target: self action: #addREPL.
			aMenu add: 'add REPL and workspace' target: self action: #addWREPL.
			aMenu add: 'add dual notebook' target: self action: #dual]
		ifFalse: [aMenu add: 'go full frame' target: self action: #fullFrame].
	].

	^ aMenu
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 12/1/2011 11:03'!
buildMenu: aMenu

	self commandsHistory do: [:command |
		| str |
		str := command asString withBlanksTrimmed.
		aMenu add: (str truncateWithElipsisTo: 70)
				selector: #insertCommand: argument: str].

	self commandsHistory ifNotEmpty: [aMenu addLine].

	lastAnswer ifNotNil: [
		self proposeLastAnswer ifTrue: [
			| str |
			str := lastAnswer asString withBlanksTrimmed.
			str isEmpty ifFalse: [
				aMenu add: (str truncateWithElipsisTo: 70)
					selector: #insertCommand: argument: str]].
		aMenu add: 'explore last value' target: lastValue selector: #explore].

	evaluator addItemsToREPLMenu: aMenu.

	aMenu addLine.
	commandsHistory isEmpty ifTrue: [aMenu add: 'no history yet' action: #yourself]
		ifFalse: [
			aMenu addLine;
			add: 'display history' action: #displayHistory;
			add: 'grab history' action: #grabHistory].

	aMenu add: 'clear display' action: #clear.
			
	debugContinuation ifNotNil: [
		aMenu addLine.
		aMenu add: (('DEBUG ', lastError) truncateWithElipsisTo: 70)
			 target: debugContinuation selector: #value].

	aMenu add: (textMorph acceptOnCR ifTrue: ['<yes>'] ifFalse: ['<no>']), 'accept on CR'
		target: self 
		selector: #acceptOnCR:
		argument: textMorph acceptOnCR not.

	^ aMenu! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
buildMenu: aMenu

	model buildMenu: aMenu.
	^ aMenu! !

!Notebook class methodsFor: 'as yet unclassified' stamp: 'spfa 3/24/2013 21:40'!
buttonColor: aSymbolOrNil

	^ aSymbolOrNil caseOf: {
		[nil] -> [self buttonMorph color].
		[#trigger] -> [Color gold lighter lighter].
		[#locked] -> [Color dustyTeal].
		[#interactive] -> [Color yellowGreen lighter lighter]}! !

!Notebook class methodsFor: 'as yet unclassified' stamp: 'spfa 3/24/2013 21:37'!
buttonMorph
	
	^ StrongButtonMorph newWithRoundedCorner
		actWhen: #buttonUp;	
		baseColor: Color whiteSmoke;
		borderColor: Color cornflowerBlue! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 3/24/2013 21:37'!
buttonMorph
	
	^ self class buttonMorph! !

!LegacyTextMorphEditor methodsFor: 'menu messages' stamp: 'spfa 4/19/2012 12:03'!
cancel
	"Cancel the changes made so far to this text"
	morph cancelEdits! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 22:18'!
cellTextWithInput: input status: aSymbol

	^ (self prompt: aSymbol), 
		(input asText addAttributes: self class commandAttributes), 
		String cr asText, self separator! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/16/2011 15:00'!
cells

	^ Array streamContents: [:str | self cellsDo: [:c | str nextPut: c]]
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
cellsDo: aBlock

	(self getMyText embeddedMorphsList select: [:m |
		m hasProperty: #notebookPrompt])
		do: [:pm | aBlock value: (NotebookCell at: pm)].
! !

!LegacyTextMorphEditor methodsFor: 'editing keys' stamp: 'spfa 4/19/2012 12:03'!
changeEmphasis: aStream
	"Change the emphasis of the current selection."
	| retval |
	retval := super changeEmphasis: aStream.
	paragraph composeAll.
	self recomputeInterval.
	morph updateFromParagraph.
	^retval! !

!LegacyTextMorphEditor methodsFor: 'attributes' stamp: 'spfa 4/19/2012 12:03'!
changeEmphasisOrAlignment
	| aList reply  code align menuList startIndex alignSymbol |
	self flag: #arNote. "Move this up once we get rid of MVC"
	startIndex := self startIndex.
	aList := #(normal bold italic narrow underlined struckOut leftFlush centered rightFlush justified).	
	align := paragraph text alignmentAt: startIndex 
		ifAbsent:[paragraph textStyle alignment].
	alignSymbol := TextAlignment alignmentSymbol: align.
	code := paragraph text emphasisAt: startIndex.
	menuList := WriteStream on: Array new.
	menuList nextPut: (code isZero ifTrue:['<on>'] ifFalse:['<off>']), 'normal' translated.
	menuList nextPutAll: (#(bold italic underlined struckOut) collect:[:emph|
		(code anyMask: (TextEmphasis perform: emph) emphasisCode)
			ifTrue:['<on>', emph asString translated]
			ifFalse:['<off>',emph asString translated]]).
	((paragraph text attributesAt: startIndex forStyle: paragraph textStyle)
		anySatisfy:[:attr| attr isKern and:[attr kern < 0]]) 
			ifTrue:[menuList nextPut:'<on>', 'narrow' translated]
			ifFalse:[menuList nextPut:'<off>', 'narrow' translated].
	menuList nextPutAll: (#(leftFlush centered rightFlush justified) collect:[:type|
		type == alignSymbol
			ifTrue:['<on>',type asString translated]
			ifFalse:['<off>',type asString translated]]).
	aList := #(normal bold italic underlined struckOut narrow leftFlush centered rightFlush justified).
	reply := UIManager default chooseFrom: menuList contents values: aList lines: #(1 6).
	reply notNil ifTrue:
		[(#(leftFlush centered rightFlush justified) includes: reply)
			ifTrue:
				[self setAlignment: reply.
				paragraph composeAll.
				self recomputeInterval]
			ifFalse:
				[self setEmphasis: reply.
				paragraph composeAll.
				self recomputeSelection.
				self mvcRedisplay]].
	^ true! !

!Notebook methodsFor: 'menu' stamp: 'spfa 11/18/2009 18:14'!
changeGeometry: aBlock

	| po am |

	(po := owner) isSystemWindow ifFalse: [^ self].
	am := po submorphs first.
	po removeAllMorphs.
	aBlock value: po.
	po addMorphFront: am
	! !

!LegacyTextMorphEditor methodsFor: 'attributes' stamp: 'spfa 4/19/2012 12:03'!
changeSelectionFontTo: aFont
	| attr |
	aFont ifNil:[^self].
	attr := TextFontReference toFont: aFont.
	paragraph text addAttribute: attr from: self startIndex to: (self stopIndex-1 min: paragraph text size).
	paragraph composeAll.
	self recomputeInterval.
	morph changed.! !

!LegacyTextMorphEditor methodsFor: 'attributes' stamp: 'spfa 4/19/2012 12:03'!
changeStyle
	"Let user change styles for the current text pane."
	| aList reply style theStyle menuList |
	self flag: #arNote. "Move this up once we get rid of MVC"
	aList := StrikeFont actualFamilyNames.
	theStyle := paragraph textStyle.
	menuList := aList collect:[:styleName|
		"Hack!! use defaultFont for comparison - we have no name that we could use for compare and the style changes with alignment so they're no longer equal."
		(TextConstants at: styleName) defaultFont == theStyle defaultFont
			ifTrue:['<on>', styleName]
			ifFalse:['<off>',styleName]].
	theStyle = TextStyle default
		ifTrue:[menuList addFirst: '<on>DefaultTextStyle']
		ifFalse:[menuList addFirst: '<off>DefaultTextStyle'].
	aList addFirst: 'DefaultTextStyle'.
	reply := UIManager default chooseFrom: menuList values: aList lines: #(1).
	reply ifNotNil:
		[(style := TextStyle named: reply) ifNil: [Beeper beep. ^ true].
		paragraph textStyle: style copy.
		paragraph composeAll.
		self recomputeSelection.
		self mvcRedisplay].
	^ true! !

!LegacyTextMorphEditor methodsFor: 'attributes' stamp: 'spfa 4/19/2012 12:03'!
changeTextFont
	"Present a dialog which allows the user to select a font, and if one is chosen, apply it to the current selection.	If there is no selection, or the selection is empty, apply it to the whole morph."
	| curFont startIndex chooser newFont |
	startIndex := self startIndex.
	curFont := (paragraph text fontAt: startIndex withStyle: paragraph textStyle).
	morph openModal: (
		Cursor wait showWhile: [ 
			(chooser := FontChooserTool default
				withTitle: 'Change the selected text''s font to...' translated
				for: self 
				setSelector: #changeSelectionFontTo:
				getSelector: curFont)
			"Do not allow changing the emphasis; we don't know how to deal with
			a 'pre-emphasized' font here, so bail."
				offerStyleList: false;
 				open]).
	newFont := chooser result.
	newFont ifNotNil:[self changeSelectionFontTo: newFont].! !

!Notebook methodsFor: 'private' stamp: 'spfa 11/27/2010 21:03'!
characterLimit

	^ Float infinity! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
characterLimit

	"we should be able to set this interactively"

	^ 30000! !

!Notebook methodsFor: 'contents' stamp: 'spfa 3/24/2013 21:38'!
checkUpCells

	((self hasProperty: #swap) or:[self hasProperty: #insert]) ifTrue: [^ self]. 

	self cellsDo: [:c | 
		c promptMorph baseColor: 
			(self class buttonColor: (c promptMorph valueOfProperty: #status))]! !

!LegacyTextMorphEditor methodsFor: 'editing keys' stamp: 'spfa 4/19/2012 12:03'!
chooseColor
	| attribute |
	attribute := TextColor color: Color black. "default"
	"Make a new Text Color Attribute, let the user pick a color, and return the attribute"
	NewColorPickerMorph useIt
		ifTrue: [ (NewColorPickerMorph on: attribute) openNear: morph fullBoundsInWorld ]
		ifFalse:
			[ ColorPickerMorph new
				 choseModalityFromPreference ;
				 sourceHand: morph activeHand ;
				 target: attribute ;
				 selector: #color: ;
				 originalColor: Color black ;
				
				putUpFor: morph
				near: morph fullBoundsInWorld ].
	^ attribute! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:14'!
clear

	self updateText: '' asText; 
			refreshDisplay: self prompt! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 4/4/2013 12:29'!
clear

	self updateText: ''.
	self refreshDisplay: self prompt.! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
closeTypeIn

	| begin stop rInterval nInterval newText |

	(UndoMessage sends: #noUndoer) ifFalse:[^super closeTypeIn].
	Preferences multipleTextUndo ifTrue: 
		[
		beginTypeInBlock == nil ifFalse:
			[
				begin := self startOfTyping.
				stop := self stopIndex.
				rInterval := (begin "+ UndoMessage argument" 
																to: begin + UndoSelection size - 1).
				nInterval := begin to: stop - 1.
				(nInterval = rInterval) ifTrue:[ ^super closeTypeIn ].
				newText := nInterval size > 0
										ifTrue: [ paragraph text 
																copyFrom: nInterval first 
																to: nInterval last ]
										ifFalse: [ self nullText ].
				self addEditCommand: 
				 	(EditCommand
							textMorph: morph
							replacedText: UndoSelection copy
							replacedTextInterval: rInterval
							newText: newText 
							newTextInterval: nInterval)
			].
		].
	
	"Call the super regardless, just to keep the standard undo machine happy"
	^super closeTypeIn
! !

!Notebook class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:14'!
commandAttributes

	^ {TextColor color: Color blue muchDarker . "TextEmphasis bold"}! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
commandAttributes

	^ {TextColor color: Color blue muchDarker}! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
commandsHistory

	^ commandsHistory ifNil: [commandsHistory := OrderedCollection new]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
comment

	^ (notebook getMyText embeddedMorphsIndexes reverseDetect: [:array |
		array key < start and: [
			(array value hasProperty: #notebookPrompt) ifTrue: [^ nil].
			array value hasProperty: #notebookComment]]
		ifNone: [^ nil]) value! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
commentColor

	^ Color grey alpha: 0.1

! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 11/29/2011 17:22'!
computeIntervalFrom: start to: stop

	| cb ce |

	model ifNil: [^ super computeIntervalFrom: start to: stop].

	cb := model startOfPointedCommand.
	ce := model endOfPointedCommand.
	
	(start min: stop) = cb ifTrue: [^ self].
	(start max: stop) = (ce + 1) ifTrue: [^ self].	

	 super computeIntervalFrom: start to: stop
! !

!Notebook methodsFor: 'storage' stamp: 'spfa 5/23/2010 23:18'!
constructor

	^ String streamContents: [:str |
		self class storeOn: str.
		str nextPutAll: ' new: '.
		self headerLabel storeOn: str. 
		str cr.
		str tab; tab; nextPutAll: 'contents: #( '; cr.
		self stringContents do: [:cell |
			str tab; tab; tab.
			cell isString ifTrue: [cell storeOn: str].
			cell isArray ifTrue: [str nextPutAll: cell printString allButFirst].
			str cr].
		str tab; tab; nextPutAll: ')'].


! !

!Notebook methodsFor: 'storage' stamp: 'spfa 4/2/2010 11:10'!
contents

	^ Array streamContents: [:str |
		self cellsDo: [:cell | 
			| comment |
			((comment := cell comment) isNil and: [cell status isNil])
				ifTrue: [str nextPut: cell inputString]
				ifFalse: [
					str nextPut: {
							comment ifNotNil: [comment contents asString].
							cell inputString.
							cell status
						}]]]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
contents

	| text |

	text := notebook getMyText.

	end = text size ifTrue:
		[^ text copyFrom: start to: end].

	^ text copyFrom: start to: end -1! !

!LegacyTextMorphEditor methodsFor: 'controlling' stamp: 'spfa 4/19/2012 12:03'!
controlInitialize
	"No-op for MVC ParagraphEditor compatibility"! !

!LegacyTextMorphEditor methodsFor: 'controlling' stamp: 'spfa 4/19/2012 12:03'!
controlTerminate
	"No-op for MVC ParagraphEditor compatibility"! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/7/2010 19:30'!
controlsWrapper

	^ self morphWrapper cellInset: 1; layoutInset: 1! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/11/2010 15:08'!
copyComment

	notebook setProperty: #cutComment toValue: (self comment ifNil: [^ self]) contents.
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/3/2011 11:54'!
crop

	self isLocked ifTrue: [^ self].
	
	self replaceFrom: start-1 to: end with: ''.
	self comment ifNotNil: [self removeComment].
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/29/2011 17:09'!
currentCommand

	^ self currentCommandFor: self text! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/29/2011 10:48'!
currentCommandFor: text

	|  lastLine  |

	lastLine := text copyFrom: self startOfCurrentCommand to: text size.
	^ lastLine asString withBlanksTrimmed! !

!REPLTextMorphEditor methodsFor: 'not yet implemented' stamp: 'spfa 11/29/2011 10:53'!
cursorDown: characterStream 

	^ true! !

!REPLTextMorphEditor methodsFor: 'not yet implemented' stamp: 'spfa 11/29/2011 10:53'!
cursorEnd: characterStream 

	^ true! !

!REPLTextMorphEditor methodsFor: 'not yet implemented' stamp: 'spfa 11/29/2011 10:53'!
cursorHome: characterStream 

	^ true! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 11/29/2011 17:35'!
cursorPageDown: characterStream 

	self isOnPromptLine
		ifTrue: [model insertNextCommand. ^ true].
		
	^ true
! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 11/29/2011 17:35'!
cursorPageUp: characterStream 

	self isOnPromptLine
		ifTrue: [model insertPreviousCommand. ^ true].
		
	^ true
! !

!REPLTextMorphEditor methodsFor: 'not yet implemented' stamp: 'spfa 11/29/2011 10:54'!
cursorTopHome: characterStream 

	^ true! !

!REPLTextMorphEditor methodsFor: 'not yet implemented' stamp: 'spfa 11/29/2011 10:53'!
cursorUp: characterStream 

	^ true! !

!LegacyTextMorphEditor methodsFor: 'typing support' stamp: 'spfa 4/19/2012 12:03'!
dispatchOnCharacter: char with: typeAheadStream
	"Carry out the action associated with this character, if any.
	Type-ahead is passed so some routines can flush or use it."

	((char == Character cr) and: [morph acceptOnCR])
		ifTrue:
			[sensor keyboard.  "Gobble cr -- probably unnecessary."
			self closeTypeIn.
			^ true].

	^ super dispatchOnCharacter: char with: typeAheadStream! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
displayAttribute

	^ TextColor color: Color red muchDarker muchDarker! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
displayFont

	^ ((TextStyle named: #Accumon) ifNil: [^ TextStyle defaultFont])
		fontOfSize: TextStyle defaultFont pointSize! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
displayFontAttribute

	^ TextFontReference toFont: self displayFont! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 9/20/2010 09:59'!
displayHistory

	StringHolder new 
		acceptContents: (String streamContents: [:str |
			self commandsHistory do: [:command |
				str nextPutAll: command; cr]]); 
		openLabel: 'commands history'
	! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 4/2/2010 13:50'!
doCommand: aString

	self doCommand: aString register: true! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/29/2011 14:27'!
doCommand: aString

	| answer |

	self setProperty: #inCommand toValue: true.
	self registerCommand: aString.

	debugContinuation := lastAnswer := lastError := lastValue :=  nil.

	answer :=  [lastAnswer := (self formatAnswer: 
						(lastValue := self evalString: aString)) 
								asText addAttributes: self class answerAttributes]
		on: Error
		do: [:ex | 
				debugContinuation := Continuation current.
				debugContinuation isContinuation
					ifTrue: [(lastError := ex description) asText 
								addAttribute: self class errorAttribute]
					ifFalse: [ex signal]].

	self setProperty: #inCommand toValue: false.

	self appendEntry; outputQueue.
	self updateText: myContents allButLast, self separator, String cr, answer, String cr.
	self refreshDisplay: self prompt.

! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 1/10/2012 15:03'!
doCommand: aString register: rflag

	| answer |

	self setProperty: #inCommand toValue: true.
	rflag ifTrue: [self registerCommand: aString].

	debugContinuation := lastAnswer := lastError := lastValue :=  nil.

	answer :=  (self evalCommand: aString) asText
					addAttributes: self class answerAttributes.

	self setProperty: #inCommand toValue: false.

	self appendEntry; outputQueue.
	self updateText: ((self wantsAnswerDisplayFor: aString) 
		ifFalse: [myContents, self separator, String cr]
		ifTrue: [myContents, self separator, answer, String cr, String cr]).
	self refreshDisplay: self prompt.

	self selectFrom: self text size + 1 to: self text size + 1.
	self scrollSelectionIntoView; setScrollDeltas; refreshWorld.


! !

!Notebook methodsFor: 'menu' stamp: 'spfa 4/2/2010 09:33'!
dual

	self dual: (Notebook new evaluator: self evaluator) clear
		
	! !

!Notebook methodsFor: 'menu' stamp: 'spfa 4/2/2010 09:33'!
dual: aNotebook

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 0.5@1).
		sw addMorph: aNotebook
				frame: (0.5@0 corner: 1@1).]

	! !

!Notebook methodsFor: 'storage' stamp: 'spfa 5/23/2010 23:24'!
editCopyFromCells

	('(', self constructor, ') openInWorld') openInWorkspaceWithTitle: self headerLabel, ' (edit)'
! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
editHistory
	^morph editHistory
! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 11/29/2011 15:07'!
encompassLine: anInterval
	"Return an interval that encompasses the entire line, minus the promt if present at the beginning"

	^ model pointedCommandInterval! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
endEntry

	self appendEntry.
	(outputQueueProcess notNil
		and: [outputQueueProcess isTerminated not]) ifTrue: [^ self].

	outputQueueProcess := [50 milliSeconds asDelay wait . self outputQueue] fork
! !

!Notebook methodsFor: 'command processing' stamp: 'spfa 11/29/2011 17:12'!
endOfPointedCommand

	| text |

	text := self text asString.
	selectionInterval max > text size ifTrue: [^ text size + 1]. 
	^ (text indexOf: self separatorCharacter startingAt: selectionInterval last ifAbsent: [^ text size + 1]) - 1 
	! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/29/2011 17:09'!
endOfPointedCommand

	| text |

	text := self text asString.
	selectionInterval max > text size ifTrue: [^ text size + 1]. 
	^ (text indexOf: self separatorCharacter startingAt: selectionInterval last ifAbsent: [text size + 1])
	! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 11/18/2009 18:16'!
errorAttribute

	^ TextColor color: Color red! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:14'!
evalCommand: aString

	^  [lastAnswer := 
						(lastValue := evaluator evalString: aString notifying: self)
					forNotebook: self]
		on: Error
		do: [:ex | 
				debugContinuation := Continuation current.
				debugContinuation isContinuation
					ifTrue: [(lastError := ex description) asText 
								addAttribute: self class errorAttribute]
					ifFalse: [ex signal]]! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/21/2010 11:19'!
evalString: aString

	(self hasProperty: #commandController)
		ifTrue: [(self valueOfProperty: #commandController) checkCommand: aString].

	^ evaluator evalString: aString notifying: self! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
evalText: aString

	^ evaluator evalText: aString! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/16/2011 15:33'!
evaluate

	self accept.
	self cellsDo: [:cell | cell evaluateFromNotebook].
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 5/2/2012 14:57'!
evaluate

	notebook accept.
	self becomeForward: (NotebookCell at: promptMorph).
	self isLocked ifTrue: [^ self].
	self evaluateSansTrigger.
	self isTrigger ifTrue: [^ notebook evaluateSansTriggers].
	! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 10/1/2013 11:48'!
evaluateFromNotebook

	(self isPassive" or: [self isTrigger]") ifFalse: [^ self].

	self evaluateSansTrigger.
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 3/21/2010 17:15'!
evaluateSans: aNotebookCell

	self cellsDo: [:cell | 
		aNotebookCell == cell ifFalse:
			[cell evaluateFromNotebook]]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 1/10/2012 15:03'!
evaluateSansTrigger

	| input val |
		
	input := self input asString withBlanksTrimmed.
	input ifEmpty: [^ self].	

	val := (notebook evalCommand: input) asText 
			addAttributes: notebook class answerAttributes.

	(notebook wantsAnswerDisplayFor: input) ifFalse:
		[^ self output: String cr].

	self output: val, String cr, String cr! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 5/2/2012 14:56'!
evaluateSansTriggers

	self cellsDo: [:cell | 
		cell isTrigger ifFalse:
			[cell evaluateFromNotebook]]
! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 11/18/2009 18:16'!
evaluateSelection
	"Treat the current selection as an expression; evaluate it and return the result"

	self lineSelectAndEmptyCheck: [^ ''].
	^ model evalString: self selectionAsStream contents asString! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
evaluator

	^evaluator
! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
evaluator: anObject

	| fresh |

	(self hasProperty: #inCommand) ifTrue: [^ self].

	fresh := ''.

	evaluator ifNotNil: [
		self appendEntry; outputQueue.
		fresh := self freshInput. 
		[fresh beginsWith: String cr] whileTrue: [fresh := fresh allButFirst].
		(fresh beginsWith: self prompt) 
			ifTrue:	[fresh := fresh allButFirst: self prompt size]].

	evaluator := anObject.
	self appendEntry; outputQueue.
	evaluator outputStream reset.

	self refreshDisplay: self prompt, fresh

! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 1/26/2012 10:51'!
exploreIt

	| result |
	result := self evaluateSelection.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [view flash]
			ifFalse: [result explore]! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:14'!
extent: aPoint

	super extent: aPoint.

	textMorph ifNil: [^ self]. "notebook is not fully initialized yet"
	self refreshDisplay: self prompt.! !

!LegacyTextMorphEditor methodsFor: 'typing support' stamp: 'spfa 4/19/2012 12:03'!
fakeSensorWithEvent: anEvent
	"Pass the event to a polling-friendly-sensor-fake so that old st-80 code shall still work"
	self sensor: (KeyboardBuffer new startingEvent: anEvent).! !

!LegacyTextMorphEditor methodsFor: 'menu messages' stamp: 'spfa 4/19/2012 12:03'!
find
	super find.
	morph installEditorToReplace: self! !

!LegacyTextMorphEditor methodsFor: 'displaying' stamp: 'spfa 4/19/2012 12:03'!
flash
	^ morph flash! !

!Form methodsFor: '*REPLMorph' stamp: 'spfa 11/18/2009 18:10'!
forNotebook: aNotebook

	^ self asMorph forNotebook: aNotebook
! !

!Morph methodsFor: '*REPLMorph' stamp: 'spfa 10/1/2013 10:33'!
forNotebook: aNotebook

	(self hasProperty: #doNotWrapInNotebook) ifTrue: [^ self asAnchoredText].

	(self == World or: [owner notNil])
		ifTrue: [^ (self printString, ' [owner: ', owner printString, ']') asText].

	^ aNotebook wrapMorphForOutput: self
! !

!Object methodsFor: '*REPLMorph' stamp: 'spfa 8/14/2010 23:03'!
forNotebook: aNotebook

	^ aNotebook wrapForOutput: self
! !

!SimpleButtonMorph methodsFor: '*REPLMorph' stamp: 'spfa 11/18/2009 18:16'!
forNotebook: aNotebook

	^ aNotebook plainOutput: self
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 12/1/2011 20:07'!
formatAnswer: anObject

	^ [evaluator formatREPLOutput: anObject] on: Error do: [anObject printString]
	

	

	! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 11/29/2011 13:36'!
forwardDelete: characterStream

	self isInEditableForm ifFalse: [^ true].
	model atEndOfPointedCommand ifTrue: [^ true].
	^ super forwardDelete: characterStream ! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/29/2011 17:11'!
freshInput

	| len tlen text |

	text := self text.
	len := myContents ifNil: [0] ifNotNil: [myContents size].
	tlen := text size.
	tlen == len ifTrue: [^ ''].

	^ text copyFrom: len to: text size

! !

!Notebook methodsFor: 'menu' stamp: 'spfa 11/18/2009 18:14'!
fullFrame

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 1@1)]

	! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/3/2011 11:06'!
getButton

	| input label |

	input := self input asString withBlanksTrimmed.
	input ifEmpty: [^ self].		
	
	label := FillInTheBlankMorph 
				request: 'button label'
				initialAnswer: input.
	label ifEmpty: [^ self].	

	(SimpleButtonMorph newWithRoundedCorner
		setProperty: #targetReferenceForDeepCopying toValue: notebook;
		target: notebook;
		actionSelector: #evalCommand:;
		arguments: {input};
		label: label;
		color: Color whiteSmoke;
		borderColor: Color cornflowerBlue) openInHand! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
getMyText
	^myContents! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 4/2/2010 14:51'!
getValue

	^ notebook evalString: self input asString withBlanksTrimmed! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
grabHistory

	| n |

	n :=  self commandsHistory size.
	n > 0 ifFalse: [^ self].

	((StringMorph contents: n asString, ' command', (n>1 ifTrue: ['s'] ifFalse: ['']))
		setProperty: #replCommands toValue: self commandsHistory)
	openInHand
! !

!Notebook methodsFor: 'header' stamp: 'spfa 11/18/2009 18:14'!
headerFont

	^ TextStyle default fontOfSize: 30! !

!Notebook methodsFor: 'header' stamp: 'spfa 12/1/2011 18:23'!
headerLabel

	owner ifNil: [^ ''].

	^ [owner label] on: Error do: ['notebook']
! !

!Notebook methodsFor: 'header' stamp: 'spfa 4/2/2010 11:52'!
headerText

	^ Text streamContents: [:str |

		| label sbutt sabutt ebutt bbutt space |

		label := MPEGSubtitlesDisplayer on: self selector: #headerLabel.
		label font: self headerFont.
		str nextPutAll: label asAnchoredText.

		str cr.

		sbutt := self buttonMorph label: 'save'; 
			target: self lambda owner saveOnUsualFile; 
			actionSelector: #value.
		str nextPutAll: sbutt asAnchoredText.

		str nextPutAll: '  ' asText.

		sabutt := self buttonMorph label: 'save as...'; 
			target: self lambda owner saveOnFileRememberWhere; 
			actionSelector: #value.
		str nextPutAll: sabutt asAnchoredText.

		str nextPutAll: (Morph new 
				color: Color transparent; height: 10) asAnchoredText.

		ebutt := self buttonMorph label: 'evaluate'; 
			target: self ; 
			actionSelector: #evaluate.
		str nextPutAll: ebutt asAnchoredText.

		str nextPutAll: '  ' asText.

		bbutt := self buttonMorph label: 'bindings'; 
			target: self lambda evaluator bindings quoted explore ; 
			actionSelector: #value.
		str nextPutAll: bbutt asAnchoredText.

		str cr; cr]

! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
hideOutput

	| hbutt |

	hbutt := notebook buttonMorph label: 'show';
					target: (self lambda anew output: self output); 
					actionSelector: #value.

	^ self output: hbutt asAnchoredText, String cr, String cr
! !

!REPLMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 4/3/2010 18:23'!
historyLength

	^ 15! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
inSystemWindow

	^ self inSystemWindowLabelled: 'notebook'
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/28/2010 21:00'!
inSystemWindowLabelled: aString

	| w |

	w := SystemWindow labelled: aString.
	w model: self.
	w paneColor: self class windowColor.
	w addMorph: self frame: (0@0 corner: 1@1).
	^ w! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 11/28/2010 21:39'!
initialExtent

	^ 620@400! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:14'!
initialize

	super initialize.
	self getProperty: #alwaysAccept.
	self updateText: self headerText.

! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
initialize
	super initialize.
	self extent: 600@400.
	self color: Color white.
	self acceptOnCR: true.
"	self alwaysShowVScrollBar: true."
	getMenuSelector := #buildMenu:.
	self startStepping



	! !

!NotebookCell methodsFor: 'intialization' stamp: 'spfa 11/29/2011 13:45'!
initializeAt: aMorph

	| text emorphs |

	promptMorph := aMorph.

	notebook := promptMorph ownerChain detect: [:m | m isMorphicModel].
	text := notebook getMyText.

	emorphs := text embeddedMorphsIndexes.

	start := (emorphs detect: [:a |
		a value == promptMorph] ifNone: [^ nil]) key.

	end := (emorphs detect: [:a |
		a key > start 
			and: [(a value hasProperty: #notebookPrompt)
					or: [a value hasProperty: #notebookComment]]]
		ifNone: [text size -> #theEnd]) key.

	endInput := (text indexOf: notebook separatorCharacter 
					startingAt: start ifAbsent: []) -1.
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
input

	notebook class commandAttributes do: [:att |
		notebook getMyText addAttribute: att from: start + 1 to: endInput].

	^ notebook getMyText copyFrom: start + 1 to: endInput
			 ! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
input: aText

	^ self replaceFrom: start+1 to: endInput with: aText! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
inputString

	^ (notebook getMyText asString copyFrom: start + 1 to: endInput - 1)
		withBlanksTrimmed
			 ! !

!Notebook methodsFor: 'contents' stamp: 'spfa 3/24/2010 15:12'!
insert: aMorph

	aMorph setProperty: #passiveColor toValue: aMorph color.
	self setProperty: #insert toValue: aMorph.
	aMorph color: Color orange! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 22:16'!
insertBefore: aButtonMorph
	
	| promptMorph tempText first fc sc |

	promptMorph := self valueOfProperty: #insert.
	self removeProperty: #insert.
	promptMorph color: (promptMorph valueOfProperty: #passiveColor).
	promptMorph == aButtonMorph ifTrue: [^ self].

	(self hasProperty: #swapComments) ifTrue: [	
		fc := (NotebookCell at: promptMorph) comment.
		sc := (NotebookCell at: aButtonMorph) comment].

	first := (NotebookCell at: promptMorph).
	tempText := first contents allButLast.
	first crop.
	(NotebookCell at: aButtonMorph) prepend: String cr asText, tempText.	

	(self hasProperty: #swapComments) ifTrue: [		
		sc ifNotNil: [(NotebookCell at: promptMorph) removeComment].
		sc ifNotNil: [(NotebookCell at: aButtonMorph) prependComment: sc contents].	
		fc ifNotNil: [(NotebookCell at: promptMorph) prependComment: fc contents]].			
	
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/12/2010 02:05'!
insertCell

	self prepend: String cr asText, (notebook cellTextWithInput: '' status: nil)! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
insertCommand: aString

	textMorph newContents: (Text streamContents: [:str |

		| txt |

		str nextPutAll: (myContents ifNil: ['']).

		(self hasProperty: #inCommand) ifFalse: [
			myContents isEmptyOrNil ifFalse: [
				myContents last == Character cr ifFalse: [str cr]].
			str nextPutAll: self prompt].

		txt := (Text fromString: aString) 
					addAttributes: self class commandAttributes.
		(self hasProperty: #inCommand) 
			ifTrue: [txt addAttribute: self class displayFontAttribute].
		str nextPutAll: txt]).

	textMorph editor selectAt: textMorph asText size + 1.
	self hasUnacceptedEdits: true! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
insertNextCommand

	| command |
	self commandsHistory ifEmpty: [^ self].
	self insertCommand: (command := commandsHistory first).
	commandsHistory removeFirst.
	commandsHistory addLast: command! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
insertPreviousCommand

	| command |
	self commandsHistory ifEmpty: [^ self].
	self insertCommand: (command := commandsHistory last).
	commandsHistory removeLast.
	commandsHistory addFirst: command! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 1/26/2012 10:51'!
inspectIt

	| result |
	result := self evaluateSelection.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [view flash]
			ifFalse: [result inspect]! !

!LegacyTextMorphEditor methodsFor: 'editing keys' stamp: 'spfa 4/19/2012 12:03'!
inspectIt: characterStream 
	"Inspect the selection -- invoked via cmd-i.  If there is no current selection, use the current line."

	sensor keyboard.		"flush character"
	self inspectIt.
	^ true! !

!REPLTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
installEditorToReplace: priorEditor
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [stateArray := priorEditor stateArray].
	editor := REPLTextMorphEditor new morph: self.
	editor changeParagraph: self paragraph.
	priorEditor ifNotNil: [editor stateArrayPut: stateArray].
	self selectionChanged.
	^ editor! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 11/29/2011 11:04'!
isInEditableForm

	| pC |

	self isOnPromptLine ifTrue: [^ true].

	pC := model pointedCommand.
	^ pC notNil and: [pC notEmpty] ! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
isInTypeRun
	^beginTypeInBlock ~~ nil
! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 3/21/2010 17:16'!
isInteractive

	^ (promptMorph valueOfProperty: #status) == #interactive! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 12/3/2011 11:20'!
isLocked

	^ (promptMorph valueOfProperty: #status) == #locked! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 6/14/2012 22:29'!
isOnPromptLine

	^ (((model ifNil: [^ true]) text ifNil: [^ true]) lastIndexOf: model promptCharacter) 
		< self selectionInterval max
! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 12/21/2012 13:40'!
isOnPromptLine

	^ [model isOnPromptLine] 
		on: Error do: [(model getMyText ifNil: [^ true]) size < self selectionInterval max]
! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 3/21/2010 17:16'!
isPassive

	^ (promptMorph valueOfProperty: #status) isNil! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 3/21/2010 17:16'!
isTrigger

	^ (promptMorph valueOfProperty: #status) == #trigger! !

!LegacyTextMorphEditor methodsFor: 'events' stamp: 'spfa 4/19/2012 12:03'!
keyStroke: anEvent
	self fakeSensorWithEvent: anEvent.
	self readKeyboard! !

!REPLTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 11/30/2011 14:21'!
keyStroke: evt
	
	"always accept on shift+cr"
	(evt shiftPressed and: [evt keyCharacter = Character cr])
		ifTrue: [^ self editor accept].
		
	super keyStroke: evt! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
lastCell

	^ NotebookCell at: (myContents embeddedMorphsList reverseDetect: [:m | 
								m hasProperty: #notebookPrompt])! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/29/2011 13:45'!
liveInput

	| ibeg iend |

	ibeg := (notebook text embeddedMorphsIndexes detect: [:a |
		a value == promptMorph] ifNone: [^ nil]) key.

	iend := (notebook text indexOf: notebook separatorCharacter 
		startingAt: ibeg ifAbsent: [^ nil]) -1.

	^ (notebook text copyFrom: ibeg + 1 to: iend -1) asString withBlanksTrimmed! !

!Interval methodsFor: '*REPLMorph' stamp: 'spfa 11/29/2011 15:39'!
max

	^ start max: stop! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 12/3/2011 11:20'!
menu

	| m comment |

	m := MenuMorph new defaultTarget: notebook; thenAction: #checkUpCells.

	m 
	add: 'evaluate' target: self selector: #evaluate.

	m
	addLine;
	add: {
		'passive' -> nil.
		'locked' -> #locked.
		'trigger' -> #trigger.
		'interactive' -> #interactive.
	} valuesForProperty: #status target: promptMorph.	
	
	m addLine;
	add: 'hide output' target: self action: #hideOutput;
	add: 'remove output' target: self action: #removeOutput ;
	add: 'insert cell' target: self action: #insertCell;	
	addLine;
	add: 'swap with ...' selector: #swap: argument: promptMorph;
	add: 'insert before ...' selector: #insert: argument: promptMorph;	
	add: 'with comments' toggleForProperty: #swapComments target: notebook;
	addLine.

	(comment := self comment) ifNil:
		[
		(notebook hasProperty: #cutComment)
			ifTrue: [m add: 'paste comment' target: self action: #pasteComment].
		m add: 'add comment' target: self action: #prependComment]
		ifNotNil: [
			m add: 'select comment' target: comment action: #addHalo;
			add: 'copy comment' target: self action: #copyComment;
			add: 'cut comment' target: self action: #removeComment].

	m addLine;
	add: 'get button' target: self action: #getButton;
	addLine;
	add: 'delete' target: self action: #crop.

	^ m ! !

!Interval methodsFor: '*REPLMorph' stamp: 'spfa 11/29/2011 15:39'!
min

	^ start min: stop! !

!LegacyTextMorphEditor methodsFor: 'accessing' stamp: 'spfa 4/19/2012 12:03'!
morph
	^ morph! !

!LegacyTextMorphEditor methodsFor: 'accessing' stamp: 'spfa 4/19/2012 12:03'!
morph: aMorph
	"Install a link back to the morph being edited (esp for text links)"
	morph := aMorph ! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/28/2010 20:56'!
morphWrapper

	^ Morph new
			extent: 3@3;
			color: Color transparent;
			layoutInset: 3;
			cellInset: 1;
			wrapCentering: #center;
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap;
			listDirection: #leftToRight;
			layoutPolicy: TableLayout new! !

!LegacyTextMorphEditor methodsFor: 'events' stamp: 'spfa 4/19/2012 12:03'!
mouseDown: evt 
	"An attempt to break up the old processRedButton code into threee phases"
	| clickPoint |

	oldInterval := self selectionInterval.
	clickPoint := evt cursorPoint.
	(paragraph clickAt: clickPoint for: model controller: self) ifTrue: [
		pivotBlock := paragraph characterBlockAtPoint: clickPoint.
		self markBlock: pivotBlock.
		self pointBlock: pivotBlock.
		evt hand releaseKeyboardFocus: self.
		^ self].
	evt shiftPressed
		ifFalse:
			[self closeTypeIn.
			pivotBlock := paragraph characterBlockAtPoint: clickPoint.
			self markBlock: pivotBlock.
			self pointBlock: pivotBlock.]
		ifTrue:
			[self closeTypeIn.
			self mouseMove: evt].
	self storeSelectionInParagraph! !

!LegacyTextMorphEditor methodsFor: 'events' stamp: 'spfa 4/19/2012 12:03'!
mouseMove: evt 
	"Change the selection in response to moue-down drag"

	pivotBlock ifNil: [^ self].  "Patched during clickAt: repair"
	self pointBlock: (paragraph characterBlockAtPoint: (evt cursorPoint)).
	self storeSelectionInParagraph! !

!LegacyTextMorphEditor methodsFor: 'events' stamp: 'spfa 4/19/2012 12:03'!
mouseUp: evt
	"An attempt to break up the old processRedButton code into threee phases"
	oldInterval ifNil: [^ self].  "Patched during clickAt: repair"
	(self hasCaret 
		and: [oldInterval = self selectionInterval])
		ifTrue: [self selectWord].
	self setEmphasisHere.
	(self isDisjointFrom: oldInterval) ifTrue:
		[otherInterval := oldInterval].
	self storeSelectionInParagraph! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
multiRedo
	^self multiRedoWithCount: 1
! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
multiRedo: readAheadStream
	sensor keyboard. 	"flush character"
	self closeTypeIn.
	self multiRedoWithCount: 1.
	^true
! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
multiRedoWithCount: count

	| command i lastCommand newSelection saveSelection history |

	count > 0 ifFalse:[ ^self ].

	history := self editHistory.
	(command := history nextCommand) isNil
			ifTrue:[ ^self multiUndoError: 'Nothing to redo'].

	saveSelection := self selectionInterval.
	self deselect.
	i := 0.
	[i < count] whileTrue: 
		[
		history redo.
		lastCommand := command.
		((i := i + 1) < count) ifTrue:
			[
			(command := history nextCommand) ifNil:[
				self multiUndoError: ('Only ', (i - 1) asString, ' commands to redo.').
				i := count.]]].

	(newSelection := lastCommand redoSelectionInterval) isNil
			ifTrue:[ self selectInterval: saveSelection]
			ifFalse:[ self selectInterval: newSelection].

! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
multiUndo
	^self multiUndoWithCount: 1
! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
multiUndoError: eString

	Beeper beep
! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
multiUndoWithCount: count

	| command i lastCommand saveSelection newSelection history |

	count > 0 ifFalse:[ ^self ].
	history := self editHistory.
	(command := history commandToUndo) 
		ifNil:[ ^self multiUndoError: 'Nothing to undo'].
		
	saveSelection := self selectionInterval.
	self deselect.
	i := 0.
	[i < count] whileTrue: 
		[history undo.
		lastCommand := command.
		((i := i + 1) < count) ifTrue:
			[(command := history commandToUndo) ifNil:[
				self multiUndoError: ('Only ', (i - 1) asString, ' commands to undo.').
				i := count. ]]].

	(newSelection := lastCommand undoSelectionInterval) isNil
			ifTrue:[ self selectInterval: saveSelection]
			ifFalse:[ self selectInterval: newSelection].

! !

!LegacyTextMorphEditor methodsFor: 'menu messages' stamp: 'spfa 4/19/2012 12:03'!
mvcRedisplay
	"Ignore mvcRedisplay requests."! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 10/1/2013 09:45'!
new: aString bindings: aDictionary contents: anArray evaluate: aBoolean

	| nb who winb |

	who := thisContext sender method who.

	nb := self newStandAlone. 
	anArray do: [:cell |
		cell isString ifTrue: [nb addCell: cell comment: nil status: nil].
		cell isArray ifTrue: [nb addCell: cell second comment: cell first 
					status: (cell size = 3 ifTrue: [cell third] ifFalse: [nil])]].

	nb scroller offset: 0@0.

	((who first ~= #unknown) and: 
		[(who first firstPrecodeCommentFor: who second) = 'rewritable']) ifTrue: [
			nb setProperty: #storage 
				toValue: (MessageSend receiver: who first theNonMetaClass 
							selector: who second)].

	nb checkUpCells.
	winb := nb inSystemWindowLabelled: aString.
	
	aDictionary ifNotNil: [nb evaluator bindings: aDictionary].
	
	aBoolean ifTrue: [nb cellsDo: [:cell | cell evaluateFromNotebook]].
	
	nb vScrollBarValue: 0.
	
	^ winb
	! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 11/18/2011 10:03'!
new: aString contents: anArray

	^ self new: aString contents: anArray evaluate: false
	! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 10/1/2013 09:45'!
new: aString contents: anArray evaluate: aBoolean

	^ self new: aString bindings: nil contents: anArray evaluate: aBoolean! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
newComment: contents

	| tm comment w h |

 	tm :=  TextMorph new. 
	tm backgroundColor: self commentColor.
	tm autoFit: true; margins: 5; contents: contents.
	tm getProperty: #notebookComment.

	comment := String cr asText, tm asAnchoredText.

	w := self width - 20.
	h := (tm textStyle defaultFont approxWidthOfText: tm contents)
			* tm textStyle defaultFont height / (w + 1).

	tm wrapFlag: true.
	tm extent: w @ h asInteger.

	^ comment

! !

!REPLMorph class methodsFor: 'instance creation' stamp: 'spfa 11/12/2010 12:57'!
newStandAlone

	| nb pm |

	pm := PluggableMemory for: (nb := self new).
	nb evaluator: pm.

	^ nb
	! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
noUndoReplace: anInterval with: aText
"This is the zap that multilevel undo uses to do edits. This method bypasses any undo/redo plumbing (in contrast to zapSelection:).  This method is called by an EditCommand (which wants to carry out its paragraph surgery without adding another command to the editHistory)"

	| start stop |
	self deselect.
	start := (anInterval first max: 1).
	stop := (anInterval last min: paragraph text size).
	(aText isEmpty and: [stop > start]) ifTrue:
		["If deleting, then set emphasisHere from 1st character of the deletion"
		emphasisHere := (paragraph text attributesAt: start forStyle: paragraph textStyle)
					select: [:att | att mayBeExtended]].
"Debug dShow: ('zap start->stop: ', (start to: stop) asString)."
	paragraph 
		replaceFrom: start 
		to: stop 
		with: aText 
		displaying: false.  

	UndoMessage sends: #noUndoer . "Keep the normal undo machine happy"
	self userHasEdited  " -- note text now dirty"
! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:14'!
notebook: anObject
	notebook := anObject! !

!LegacyTextMorphEditor methodsFor: 'attributes' stamp: 'spfa 4/19/2012 12:03'!
offerFontMenu
	"Present a menu of available fonts, and if one is chosen, apply it to the current selection.  
	Use only names of Fonts of this paragraph  "
	| aList reply curFont menuList |
true ifTrue:[^self changeTextFont].
	self flag: #arNote. "Move this up once we get rid of MVC"
	curFont := (paragraph text fontAt: self startIndex withStyle: paragraph textStyle) fontNameWithPointSize.
	aList := paragraph textStyle fontNamesWithPointSizes.
	menuList := aList collect:[:fntName|
		fntName = curFont ifTrue:['<on>',fntName] ifFalse:['<off>',fntName]].
	reply := UIManager default chooseFrom: menuList values: aList.
	reply ~~ nil ifTrue:
		[self replaceSelectionWith:
			(Text string: self selection asString 
				attribute: (TextFontChange fontNumber: (aList indexOf: reply)))] ! !

!LegacyTextMorphEditor methodsFor: 'menu commands' stamp: 'spfa 4/19/2012 12:03'!
offerMenuFromEsc: characterStream 
	"The escape key was hit while the receiver has the keyboard focus; take action"

	^ ActiveEvent shiftPressed 
		ifTrue:
			[self escapeToDesktop: characterStream]
		ifFalse:
			[self raiseContextMenu: characterStream]! !

!REPLMorph class methodsFor: 'instance creation' stamp: 'spfa 11/18/2009 18:16'!
on: anObject

	^ self new evaluator: anObject! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 12/2/2011 15:06'!
openNew

	self newStandAlone inSystemWindow openInWorld! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 12/1/2011 20:13'!
openOn: anObject

	(Notebook on: anObject) inSystemWindow openInWorld! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
output

	end == notebook getMyText size
		ifTrue: [^ notebook getMyText copyFrom: endInput+1 to: end].

	^ notebook getMyText copyFrom: endInput+1 to: end-1! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
output: aText

	^ self replaceFrom: endInput + 1 to: end with: aText! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
outputQueue

	| fresh |

	self queue isEmpty ifTrue: [^ self].

	fresh := self freshInput. 

	self updateText: (Text streamContents: [:stream |
							stream nextPutAll: (myContents ifNil: ['']).
							self queue size timesRepeat: 
								[stream nextPutAll: self queue next]]).

	self refreshDisplay: fresh! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
overwriteWith: aText

	^ self replaceFrom: start-1 to: end with: aText
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/11/2010 14:56'!
pasteComment

	self prependComment: (notebook valueOfProperty: #cutComment)
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
plainOutput: aMorph

	| m |

	m := Morph new
			extent: 3@3;
			color: Color transparent;
			layoutInset: 3;
			cellInset: 3;
			wrapCentering: #center;
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap;
			listDirection: #leftToRight;
			layoutPolicy: TableLayout new.

	m addMorph: aMorph.

	^ m asAnchoredText
! !

!Notebook methodsFor: 'command processing' stamp: 'spfa 11/30/2011 11:23'!
pointedCommand

	| beg end text line |

	text := self text asString.
	end := self endOfPointedCommand.
	beg := self startOfPointedCommand.	
		
	end > text size ifTrue: [^ nil] "not quite good".
	(selectionInterval min = end) ifTrue: [^ nil]. "no command pointed on cr (next line)"
	line := text asString copyFrom: beg + 2 to: end.

	(line includes: self separatorCharacter) ifTrue: [^ nil].
	(line includes: self promptCharacter) ifTrue: [^ nil].
				
	^ line withBlanksTrimmed! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/29/2011 17:09'!
pointedCommand

	| beg end text line |

	text := self text asString.
	end := self endOfPointedCommand.
	beg := self startOfPointedCommand.	
		
	end > text size ifTrue: [^ nil] "not quite good".
	line := text asString copyFrom: beg + 2 to: end - 1.

	(line includes: self promptSeparator) ifTrue: [^ nil].
	(line includes: self separatorCharacter) ifTrue: [^ nil].
				
	^ line withBlanksTrimmed! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/30/2011 11:06'!
pointedCommandBeforeCursor

	| beg end text |

	text := self text asString.
	end := selectionInterval min.
	beg := self startOfPointedCommand.	

	^ text asString copyFrom: beg + 2 to: end.
! !

!Notebook methodsFor: 'command processing' stamp: 'spfa 11/29/2011 15:10'!
pointedCommandInterval

	| beg end |

	end := self endOfPointedCommand.
	beg := self startOfPointedCommand.	
		
	^ beg + 1 to: end - 1! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/29/2011 15:08'!
pointedCommandInterval

	| beg end |

	end := self endOfPointedCommand.
	beg := self startOfPointedCommand.	
		
	^ beg + 2 to: end - 1! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/11/2010 22:10'!
prepend: aText

	| fullText  |

	fullText := notebook getMyText.

	start < 3 ifTrue: 
		[notebook updateText: aText, fullText] 
	ifFalse: [ 
		notebook updateText: (fullText copyFrom: 1 to: start -2), 
			aText,
			(fullText copyFrom: start -1 to: fullText size)].

	notebook refreshDisplay: notebook prompt.! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:14'!
prependComment

	self prependComment:  ' ... blah ... '! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/11/2010 22:12'!
prependComment: aText

	self prepend: (notebook newComment: aText)! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 11/18/2009 18:16'!
printIt
	"Treat the current text selection as an expression; evaluate it. Insert the 
	description of the result of evaluation after the selection and then make 
	this description the new text selection."
	| result |
	result := self evaluateSelection.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [view flash]
			ifFalse: [self afterSelectionInsertAndSelect: (result printString)]! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 4/2/2010 11:14'!
prompt
	
	^ self prompt: nil! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 12/1/2011 09:30'!
prompt
	
	^ ((evaluator ifNil: [^ '> ', self promptSeparator]) 
		prompt ifNil: ['>']), ' ', self promptSeparator! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 11/29/2011 14:13'!
prompt: aSymbol
	
	| m |

	m := self buttonMorph
		target: self;
		actionSelector: #promptMenu:;
		label: '>'.

	m getProperty: #notebookPrompt.
	m arguments: {m}.

	aSymbol ifNotNil: [m setProperty: #status toValue: aSymbol].

	^ m asAnchoredText, ' ' asText
! !

!Notebook class methodsFor: 'as yet unclassified' stamp: 'muOuser 2/9/2014 14:17'!
promptCharacter

	^ Character value: 1 "see Morph>>#asAnchoredText"! !

!Notebook methodsFor: 'buttons' stamp: 'muOuser 2/9/2014 14:17'!
promptCharacter

	^ self class promptCharacter! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 14:49'!
promptMenu: aButtonMorph
	
	| cell |

	cell := (NotebookCell at: aButtonMorph) ifNil: [^ self].

	(self hasProperty: #swap) ifTrue: [^ self swapWith: aButtonMorph].
	(self hasProperty: #insert) ifTrue: [^ self insertBefore: aButtonMorph].
	
	^ cell menu popUpInWorld
! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
promptMorph
	^promptMorph! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
promptMorph: anObject
	promptMorph := anObject! !

!REPLMorph methodsFor: 'initialization' stamp: 'muOuser 2/9/2014 14:14'!
promptSeparator
	
	^ self class promptSeparator! !

!REPLMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 2/9/2014 15:39'!
promptSeparator
	
	^ (SystemVersion current majorMinorVersion >= 'Squeak4.5')
		ifTrue: [Character value: 3]
		ifFalse: [Character value: 1]! !

!Notebook methodsFor: 'menu' stamp: 'spfa 4/3/2010 18:20'!
proposeLastAnswer

	^ false
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 4/3/2010 18:20'!
proposeLastAnswer

	^ true
! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
queue

	^ queue ifNil: [queue := SharedQueue new]! !

!LegacyTextMorphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'spfa 4/19/2012 12:03'!
raiseContextMenu: characterStream 
	(morph respondsTo: #editView)
		ifTrue: [morph editView yellowButtonActivity: ActiveEvent shiftPressed]
		ifFalse: [sensor keyboard.
			"consume the character"
			morph yellowButtonActivity: false].
	^ true! !

!LegacyTextMorphEditor methodsFor: 'typing support' stamp: 'spfa 4/19/2012 12:03'!
readKeyboard
	super readKeyboard.
	self storeSelectionInParagraph! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 4/4/2013 12:28'!
rebuild

	self updateText: self getMyText.
	self refreshDisplay: self prompt.! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:15'!
refresh

	self input: (self liveInput ifNil: [^ self]).
	self anew evaluate! !

!Notebook methodsFor: 'contents' stamp: 'spfa 11/28/2010 22:07'!
refreshDisplay: aString

	| fullText |

	fullText := myContents ifNil: [aString] 
		ifNotNil: [myContents, aString].

	geometriesCache := IdentityDictionary new.

	fullText embeddedMorphs do: [:m |
		(m hasProperty: #notebookComment)
			ifTrue: [m extent: (self width - 20) @ m height.].
		geometriesCache add: m -> m extent].

	textMorph newContents: fullText.
	self selectFrom: fullText size + 1 to: fullText size + 1.
	self selectionInterval: (self text size + 1 to: self text size + 1)	

! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
refreshDisplay: freshText

	| fullText |

	fullText := myContents ifNil: [freshText] 
		ifNotNil: [myContents, freshText].
	textMorph newContents: fullText.
	self selectFrom: fullText size + 1 to: fullText size + 1.
	self scrollSelectionIntoView; setScrollDeltas; refreshWorld.
	

! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
registerCommand: aString

	self commandsHistory remove: aString ifAbsent: [].
	commandsHistory addFirst: aString.
	commandsHistory size > self class historyLength
		 ifTrue: [commandsHistory removeLast].
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
removeAllOutput

	self cellsDo: [:cell | cell removeOutput]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 8/11/2010 14:59'!
removeComment

	| fullText  |

	fullText := notebook getMyText.

	self copyComment.

	start < 4 ifTrue: [
		notebook updateText: (fullText copyFrom: start to: fullText size)] 
	ifFalse: [ 
		notebook updateText: (fullText copyFrom: 1 to: start -4), 
			(fullText copyFrom: start -1 to: fullText size)].

	notebook refreshDisplay: notebook prompt.! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/3/2011 11:54'!
removeOutput

	self isLocked ifTrue: [^ self].

	^ self output: String cr
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 11/18/2009 18:15'!
replaceFrom: anIndex to: bIndex with: aText

	| emorphs fullText |

	fullText := notebook getMyText.
	emorphs := fullText embeddedMorphsFrom: anIndex to: bIndex. 

	notebook updateText: (bIndex = fullText size ifTrue: 
			[(fullText copyFrom: 1 to: anIndex), aText]
		ifFalse: [(fullText copyFrom: 1 to: anIndex), aText,
					(fullText copyFrom: bIndex to: fullText size)]).

	emorphs do: [:m | m delete].

	notebook refreshDisplay: notebook prompt! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 4/9/2010 00:57'!
resetCommandsHistory

	^ commandsHistory := lastAnswer := lastError := lastValue := nil
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/18/2009 18:14'!
rewritedFromCells

	(Notebook new: self headerLabel
		contents: self contents) openInWorld
! !

!Notebook methodsFor: 'private' stamp: 'spfa 9/7/2010 20:35'!
scrollBar

	^ scrollBar! !

!LegacyTextMorphEditor methodsFor: 'scrolling' stamp: 'spfa 4/19/2012 12:03'!
scrollBy: ignore 
	"Ignore scroll requests."! !

!LegacyTextMorphEditor methodsFor: 'current selection' stamp: 'spfa 4/19/2012 12:03'!
select
	"Ignore selection redraw requests."! !

!LegacyTextMorphEditor methodsFor: 'current selection' stamp: 'spfa 4/19/2012 12:03'!
selectAndScroll
	"Ignore scroll requests."! !

!LegacyTextMorphEditor methodsFor: 'mvc compatibility' stamp: 'spfa 4/19/2012 12:03'!
selectAndScrollToTop
	"Scroll until the selection is in the view and then highlight it."

	| lineHeight deltaY rect deltaX |
	lineHeight := paragraph textStyle lineGrid.
	rect := morph owner bounds.
	deltaY := self stopBlock top - rect top.
	deltaY ~= 0 ifTrue: [
		deltaX := 0.
		deltaY := (deltaY abs + lineHeight - 1 truncateTo: lineHeight) negated.
		morph editView scrollBy: deltaX@deltaY]! !

!LegacyTextMorphEditor methodsFor: 'mvc compatibility' stamp: 'spfa 4/19/2012 12:03'!
selectForTopFrom: start to: stop

	self selectFrom: start to: stop.
	morph editView ifNotNil: [self selectAndScrollToTop]! !

!LegacyTextMorphEditor methodsFor: 'new selection' stamp: 'spfa 4/19/2012 12:03'!
selectFrom: start to: stop
	"Select the specified characters inclusive."
	self selectInvisiblyFrom: start to: stop.
	self closeTypeIn.
	self storeSelectionInParagraph.
	self setEmphasisHere.
! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'muOuser 2/9/2014 14:16'!
selection

	^ super selection copyWithoutAll: {
		Notebook promptCharacter.
		REPLMorph separatorCharacter. 
		REPLMorph promptSeparator}
! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 1/14/2012 14:27'!
selectionAsStream
	"Answer a ReadStream on the text in the paragraph that is currently 
	selected."

	^PositionableStream
		on: paragraph string
		from: self startIndex
		to: self stopIndex - 1! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
semaphore

	^ semaphore ifNil: [semaphore := Semaphore forMutualExclusion]! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 11/29/2011 14:20'!
separator

	^ self separatorCharacter asText
		addAttribute: (TextColor color: Color transparent)
		from: 1
		to: 1! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/29/2011 14:21'!
separator

	^ self separatorCharacter asText
		addAttribute: (TextColor color: Color transparent)
		from: 1 to: 1! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'muOuser 2/9/2014 14:15'!
separatorCharacter

	^ self class separatorCharacter! !

!REPLMorph class methodsFor: 'as yet unclassified' stamp: 'muOuser 2/9/2014 14:14'!
separatorCharacter

	^ Character value: 2! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 1/10/2012 14:59'!
setMyText: text

	| command  |

	(self hasProperty: #inCommand)
	ifTrue:
	[ | psize form |
		psize := myContents size.
		(psize <= text size) ifTrue:
		[
			self updateText: 
				((text, String cr) 
					addAttributes: self class commandAttributes from: psize + 1 to: text size+1;
					addAttribute: self class displayFontAttribute from: psize + 1 to: text size+1).
			self refreshDisplay: ''.
			form := text copyFrom: psize + 1 to: text size.
			self registerCommand: form asString.
			evaluator inputStream nextPutAll: form asString.
			evaluator inputStream skip: form size negated.
		].
		^ self 
	].

	(command := self currentCommandFor: text) isEmpty 
	ifFalse: [ 
			self updateText: text, String cr.
			self refreshDisplay: ''.
			self doCommand: command
	]
	ifTrue: [self updateText: text ].

! !

!LegacyTextMorphEditor methodsFor: 'accessing' stamp: 'spfa 4/19/2012 12:03'!
setSearch: aString
	| bk |
	"Set the FindText and ChangeText to seek aString; except if already seeking aString, leave ChangeText alone so again will repeat last replacement."

	(bk := morph ownerThatIsA: BookMorph) ifNotNil: [
		bk setProperty: #tempSearchKey 
			toValue: (aString findTokens: Character separators)].

	aString ifNotNil: [
		FindText string = aString
			ifFalse: [FindText := ChangeText := aString asText]].! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := REPLTextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := REPLTextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
spawn! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 11/18/2009 18:16'!
spawn

	! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
start

	^ start! !

!Notebook methodsFor: 'command processing' stamp: 'spfa 11/29/2011 17:13'!
startOfCurrentCommand

	| text |

	text := self text asString.
	^ (text indexOf: self promptCharacter startingAt: myContents size) + 2! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/30/2011 13:46'!
startOfCurrentCommand

	| text |

	text := self text asString.
	
	myContents ifNil: [^ (text indexOf: self promptSeparator) + 1].
	
	^ (text indexOf: self promptSeparator startingAt: myContents size) + 1! !

!Notebook methodsFor: 'command processing' stamp: 'spfa 11/29/2011 17:12'!
startOfPointedCommand

	| text |

	text := self text asString.
	selectionInterval min > text size ifTrue: [^ text size + 1]. 
	^ text lastIndexOf: self promptCharacter startingAt: selectionInterval first - 1 
		ifAbsent: [^ 0]! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/29/2011 17:10'!
startOfPointedCommand

	| text |

	text := self text asString.
	selectionInterval min > text size ifTrue: [^ text size + 1]. 
	^ (text lastIndexOf: self promptSeparator startingAt: selectionInterval first - 1 ifAbsent: [^0]) - 1
	! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 8/12/2010 02:01'!
status

	^ promptMorph valueOfProperty: #status! !

!Notebook methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:14'!
step

	(self hasProperty: #refreshDisplay) ifTrue: [
		self removeProperty: #refreshDisplay.
		^ self refreshDisplay: self prompt].

	geometriesCache ifNil: [^ self].
	geometriesCache keysAndValuesDo: [:m :xt |
		m extent ~= xt ifTrue: [^ self refreshDisplay: self prompt]]! !

!REPLMorph methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:16'!
step

	self endEntry! !

!Notebook methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:14'!
stepTime

	^ 25! !

!REPLMorph methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:16'!
stepTime

	^ 200! !

!Notebook methodsFor: 'storage' stamp: 'spfa 5/23/2010 23:23'!
storeAsSelector: aSymbol in: aClass

	aClass compileNewSelectorNamed: aSymbol streamContents: [:str |
		str tab; nextPutAll: '"rewritable"'; cr.
		str tab; nextPutAll: '^ '.
		str nextPutAll: self constructor].

	self setProperty: #storage 
		toValue: (MessageSend receiver: aClass selector: aSymbol)


! !

!Notebook methodsFor: 'storage' stamp: 'spfa 11/18/2009 18:14'!
storeAsSelector: aSymbol in: aClass classifiedUnder: bSymbol

	self storeAsSelector: aSymbol in: aClass.
	aClass class organization classify: aSymbol under: bSymbol.
! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 3/22/2010 11:24'!
storeDataOn: aDataStream

	debugContinuation := lastAnswer := lastError := lastValue :=  nil.
	super storeDataOn: aDataStream
! !

!LegacyTextMorphEditor methodsFor: 'mvc compatibility' stamp: 'spfa 4/19/2012 12:03'!
storeSelectionInParagraph
	paragraph selectionStart: self startBlock selectionStop: self stopBlock! !

!Notebook methodsFor: 'storage' stamp: 'spfa 4/2/2010 11:10'!
stringContents

	^ self contents! !

!Notebook methodsFor: 'contents' stamp: 'spfa 3/24/2010 15:12'!
swap: aMorph

	aMorph setProperty: #passiveColor toValue: aMorph color.
	self setProperty: #swap toValue: aMorph.
	aMorph color: Color orange! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/11/2010 15:25'!
swapWith: aButtonMorph
	
	| cell promptMorph tempText first second fc sc |

	cell := NotebookCell at: aButtonMorph.
	promptMorph := self valueOfProperty: #swap.
	self removeProperty: #swap.
	promptMorph color: (promptMorph valueOfProperty: #passiveColor).

	promptMorph == aButtonMorph ifTrue: [^ self].

	first := (NotebookCell at: promptMorph).
	(second := cell) start < first start 
		ifTrue: [second := first . first := cell].
		
	(self hasProperty: #swapComments) ifTrue: [	
		fc := (NotebookCell at: promptMorph) comment.
		sc := (NotebookCell at: aButtonMorph) comment].
	
	tempText := second contents.
	second overwriteWith: first contents.
	first overwriteWith: tempText.
	
	(self hasProperty: #swapComments) ifTrue: [		
		sc ifNotNil: [(NotebookCell at: promptMorph) removeComment].
		fc ifNotNil: [(NotebookCell at: aButtonMorph) removeComment].		
		sc ifNotNil: [(NotebookCell at: aButtonMorph) prependComment: sc contents].	
		fc ifNotNil: [(NotebookCell at: promptMorph) prependComment: fc contents]].			

	
	! !

!LegacyTextMorphEditor methodsFor: 'editing keys' stamp: 'spfa 4/19/2012 12:03'!
tempCommand: characterStream 
	"Experimental.  Triggered by Cmd-t; put trial cmd-key commands here to see how they work, before hanging them on their own cmd accelerators."
	Sensor keyboard.
	morph tempCommand.
	^ true! !

!LegacyTextMorphEditor methodsFor: 'attributes' stamp: 'spfa 4/19/2012 12:03'!
textAlignment
	"Answer 1..4, representing #leftFlush, #rightFlush, #centered, or #justified"
	^paragraph text alignmentAt: startBlock stringIndex
		ifAbsent: [paragraph textStyle alignment]! !

!LegacyTextMorphEditor methodsFor: 'attributes' stamp: 'spfa 4/19/2012 12:03'!
textAlignmentSymbol
	^#(leftFlush rightFlush centered justified) at: self textAlignment
	! !

!LegacyTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 4/19/2012 12:03'!
totalTextHeight

	^paragraph lines last bottom! !

!LegacyTextMorphEditor methodsFor: 'accessing' stamp: 'spfa 4/19/2012 12:03'!
transformFrom: owner
	^morph transformFrom: owner! !

!LegacyTextMorphEditor methodsFor: 'multi level undo' stamp: 'spfa 4/19/2012 12:03'!
undo
	"Reset the state of the paragraph prior to the previous edit.
	 If another ParagraphEditor instance did that edit, UndoInterval is invalid;
	 just recover the contents of the undo-buffer at the start of the paragraph."

	Preferences multipleTextUndo 
		ifTrue: [ ^self multiUndo ]
		ifFalse:[ ^super undo ].
! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/18/2009 18:16'!
update: aSymbol 

	aSymbol ifNil: [^self].

	aSymbol == #endEntry 
		ifTrue: 
			[self endEntry].

	aSymbol == #appendEntry 
		ifTrue: 
			[self appendEntry].
	aSymbol == #clearText 
		ifTrue: 
			[self clear].
	aSymbol == #force 
		ifTrue: 
			[self outputQueue].! !

!LegacyTextMorphEditor methodsFor: 'scrolling' stamp: 'spfa 4/19/2012 12:03'!
updateMarker
	"Ignore scrollbar redraw requests."
! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 11/18/2009 18:16'!
updateText: text

	| ttext |

	ttext := text size > self characterLimit 
		ifTrue: [text copyFrom: text size - self characterLimit to: text size]
		ifFalse: [text].

	super setMyText: ttext.
! !

!LegacyTextMorphEditor methodsFor: 'accessing' stamp: 'spfa 4/19/2012 12:03'!
userHasEdited
	"Note that my text is free of user edits."

	morph hasUnacceptedEdits: true! !

!LegacyTextMorphEditor methodsFor: 'mvc compatibility' stamp: 'spfa 4/19/2012 12:03'!
userHasNotEdited
	"Note that my text is free of user edits."

	morph hasUnacceptedEdits: false! !

!LegacyTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 4/19/2012 12:03'!
visibleHeight

	^morph owner bounds height! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 1/10/2012 15:07'!
wantsAnswerDisplayFor: aCommand

	^ aCommand last ~~ $. 
		
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph hasProperty: #replCommands
	
	! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:16'!
wantsFrameAdornments

	^ false! !

!Notebook methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:14'!
wantsSteps

	^ true! !

!REPLMorph methodsFor: 'stepping' stamp: 'spfa 11/18/2009 18:16'!
wantsSteps

	^ true! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 11/18/2009 18:14'!
windowColor

	^ Color greenYellow darker! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 8/14/2010 23:04'!
wrapForOutput: anObject

	anObject isSymbol ifTrue: [^ anObject storeString].

	^ anObject asString asText
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 10/1/2013 10:33'!
wrapMorphForOutput: aMorph

	| m controls hbutt hh |
	
	m := self morphWrapper.

	controls := self controlsWrapper listDirection: #topToBottom.

	m addMorph: controls.
	m addMorph: aMorph.

	hbutt := self buttonMorph label: 'show'; target: m; actionSelector: #become:.
	hbutt arguments: {hbutt}.

	hh := self controlsWrapper.
	controls addMorph: hh.
	hh addMorph: (self buttonMorph label: 'hide';
								 target: m; actionSelector: #become:;
								 arguments: {hbutt}).

	hh addMorph: (self buttonMorph label: 'halo';
								 target: aMorph; actionSelector: #addHalo).

	self addControlButtonsTo: controls for: aMorph.

	^ m asAnchoredText
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
yellowButtonActivity

	(self getMenu: false) invokeModal! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
yellowButtonActivity

	(self getMenu: false) invokeModal! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 11/18/2009 18:16'!
yellowButtonActivity: shiftKeyState

	(self getMenu: shiftKeyState) invokeModal! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:16'!
yellowButtonActivity: shiftKeyState

	(self getMenu: shiftKeyState) invokeModal! !

!LegacyTextMorphEditor methodsFor: 'events' stamp: 'spfa 4/19/2012 12:03'!
yellowButtonDown: event
	"Process a yellow button event. Answer true if the event was handled, false otherwise."
	(paragraph attributesAt: event cursorPoint) do:[:attr|
		attr menu ifNotNil:[
			attr menu openAt: event cursorPoint.
			^true]].
	^false! !

!LegacyTextMorphEditor methodsFor: 'menu messages' stamp: 'spfa 4/19/2012 12:03'!
zapSelectionWith: aText
	"**overridden to inhibit old-style display"
	| start stop rText rInterval isInTypeRun |
	self deselect.
	start := self startIndex.
	stop := self stopIndex.
	(aText isEmpty and: [stop > start]) ifTrue:
		["If deleting, then set emphasisHere from 1st character of the deletion"
		emphasisHere := (paragraph text attributesAt: start forStyle: paragraph textStyle)
					select: [:att | att mayBeExtended]].
	(start = stop and: [aText size = 0]) ifFalse:
		[
		"===Support for multilevel undo start ==="
		rText := (paragraph text copyFrom: start to: (stop - 1)).
		rInterval := start to: (stop - 1).
		isInTypeRun := self isInTypeRun.
		"===Support for multilevel undo end ==="
		
		paragraph replaceFrom: start to: stop - 1
			with: aText displaying: false.  "** was true in super"
		self wasComposition ifTrue: [wasComposition := false. self setPoint: start + 1].
		self computeIntervalFrom: start to: start + aText size - 1.
		UndoInterval := otherInterval := self selectionInterval.

		"===Support for multilevel undo start ==="
		 (Preferences multipleTextUndo and: [isInTypeRun not])ifTrue:
				[ self addEditCommand: 
							(EditCommand
									textMorph: morph
									replacedText: rText
									replacedTextInterval: rInterval
									newText: aText 
									newTextInterval: super selectionInterval)].
		"===Support for multilevel undo end ==="].

	self userHasEdited  " -- note text now dirty"! !

!REPLTextMorphEditor methodsFor: 'unclassified' stamp: 'spfa 12/21/2012 13:40'!
zapSelectionWith: aText

	self selectionInterval min isZero ifTrue: [^ self].

	"for REPLMorph, do not allow writing after the end of a command"
	(model text asString at: self selectionInterval min) = model separatorCharacter
		ifTrue: [^ self].

	(model pointedCommand notNil or: [self isOnPromptLine]) ifFalse: [^ self].

	(self isOnPromptLine 
		and: [self selectionInterval max < model startOfCurrentCommand])
	ifTrue: [^ self].

	^ super zapSelectionWith: aText! !
